<?php
include_once $_SERVER['DOCUMENT_ROOT'] . '/include/shared-manual.inc';
$TOC = array();
$TOC_DEPRECATED = array();
$PARENTS = array();
include_once dirname(__FILE__) ."/toc/langref.inc";
$setup = array (
  'home' => 
  array (
    0 => 'index.php',
    1 => 'PHP Manual',
  ),
  'head' => 
  array (
    0 => 'UTF-8',
    1 => 'fr',
  ),
  'this' => 
  array (
    0 => 'language.fibers.php',
    1 => 'Fibres',
  ),
  'up' => 
  array (
    0 => 'langref.php',
    1 => 'R&eacute;f&eacute;rence du langage',
  ),
  'prev' => 
  array (
    0 => 'language.exceptions.extending.php',
    1 => 'Etendre les Exceptions',
  ),
  'next' => 
  array (
    0 => 'language.generators.php',
    1 => 'Generators',
  ),
  'alternatives' => 
  array (
  ),
  'source' => 
  array (
    'lang' => 'fr',
    'path' => 'language/fibers.xml',
  ),
  'history' => 
  array (
  ),
);
$setup["toc"] = $TOC;
$setup["toc_deprecated"] = $TOC_DEPRECATED;
$setup["parents"] = $PARENTS;
manual_setup($setup);

contributors($setup);

?>
<div id="language.fibers" class="chapter">
 <h1 class="title">Fibres</h1>


 <div class="simplesect" id="language.fibers.overview">
  <h3 class="title">Aperçu des fibres</h3>
  <p class="verinfo">(PHP 8 &gt;= 8.1.0)</p>
  <p class="para">
   Les fibres représentent des fonctions interruptibles sur toute la pile. Les fibres peuvent être suspendues à n&#039;importe quel endroit de la pile d&#039;appels,
   en interrompant l&#039;exécution à l&#039;intérieur de la fibre jusqu&#039;à ce que la fibre soit reprise ultérieurement.
  </p>
  <p class="para">
   Les fibres mettent en pause l&#039;ensemble de la pile d&#039;exécution, de sorte que l&#039;appelant direct de la fonction n&#039;a pas besoin de modifier la façon dont il
   invoque la fonction.
  </p>
  <p class="para">
   L&#039;exécution peut être interrompue n&#039;importe où dans la pile d&#039;appels en utilisant <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span>
   (c&#039;est-à-dire que l&#039;appel à <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span> peut se trouver dans une fonction profondément imbriquée
   ou ne pas exister du tout).
  </p>
  <p class="para">
   Contrairement aux <span class="classname"><a href="class.generator.php" class="classname">Generator</a></span> n&#039;ayant pas de pile, chaque <span class="classname"><a href="class.fiber.php" class="classname">Fiber</a></span> possède sa propre pile d&#039;appels,
   ce qui leur permet d&#039;être mises en pause dans des appels de fonctions profondément imbriquées. Une fonction déclarant un point d&#039;interruption
   (c&#039;est-à-dire appelant <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span>) n&#039;a pas besoin de changer son type de retour, contrairement à une fonction utilisant
   <a href="language.generators.syntax.php#control-structures.yield" class="link">yield</a> qui doit retourner une instance de <span class="classname"><a href="class.generator.php" class="classname">Generator</a></span>.
  </p>
  <p class="para">
   Les fibres peuvent être suspendues dans n&#039;importe quel appel de fonction, y compris celles appelées à l&#039;intérieur de la VM PHP, comme les fonctions
   fournies à <span class="function"><a href="function.array-map.php" class="function">array_map()</a></span> ou les méthodes appelées par <a href="control-structures.foreach.php" class="link">foreach</a> sur un objet
   <span class="classname"><a href="class.iterator.php" class="classname">Iterator</a></span>.
  </p>
  <p class="para">
   Une fois suspendue, l&#039;exécution de la fibre peut être reprise avec n&#039;importe quelle valeur en utilisant <span class="methodname"><a href="fiber.resume.php" class="methodname">Fiber::resume()</a></span>
   ou en lançant une exception dans la fibre à l&#039;aide de <span class="methodname"><a href="fiber.throw.php" class="methodname">Fiber::throw()</a></span>. La valeur est renvoyée
   (ou l&#039;exception lancée) par <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span>.
  </p>
  <blockquote class="note"><p><strong class="note">Note</strong>: 
   <span class="simpara">
    En raison des limitations actuelles, il n&#039;est pas possible de changer de fibre dans le destructeur d&#039;un objet.
   </span>
  </p></blockquote>

  <div class="example" id="example-1018">
  <p><strong>Exemple #1 Utilisation de base</strong></p>
   <div class="example-contents">
    <div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br />$fiber </span><span style="color: #007700">= new </span><span style="color: #0000BB">Fiber</span><span style="color: #007700">(function (): </span><span style="color: #0000BB">void </span><span style="color: #007700">{<br />   </span><span style="color: #0000BB">$value </span><span style="color: #007700">= </span><span style="color: #0000BB">Fiber</span><span style="color: #007700">::</span><span style="color: #0000BB">suspend</span><span style="color: #007700">(</span><span style="color: #DD0000">'fiber'</span><span style="color: #007700">);<br />   echo </span><span style="color: #DD0000">"Valeur utilisée pour reprendre la fibre: "</span><span style="color: #007700">, </span><span style="color: #0000BB">$value</span><span style="color: #007700">, </span><span style="color: #0000BB">PHP_EOL</span><span style="color: #007700">;<br />});<br /><br /></span><span style="color: #0000BB">$value </span><span style="color: #007700">= </span><span style="color: #0000BB">$fiber</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">start</span><span style="color: #007700">();<br /><br />echo </span><span style="color: #DD0000">"Valeur de la suspension de la fibre: "</span><span style="color: #007700">, </span><span style="color: #0000BB">$value</span><span style="color: #007700">, </span><span style="color: #0000BB">PHP_EOL</span><span style="color: #007700">;<br /><br /></span><span style="color: #0000BB">$fiber</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">resume</span><span style="color: #007700">(</span><span style="color: #DD0000">'test'</span><span style="color: #007700">);<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
   </div>

   <div class="example-contents"><p>L&#039;exemple ci-dessus va afficher :</p></div>
   <div class="example-contents screen">
    <div class="cdata"><pre>
Valeur de la suspension de la fibre: fiber
Valeur utilisée pour reprendre la fibre: test
</pre></div>
   </div>
  </div>

 </div>

</div>
<?php manual_footer($setup); ?>